package com.jtauber.fop.fo;

import java.util.Vector;

import com.jtauber.fop.layout.Document;
import com.jtauber.fop.layout.FontState;
import com.jtauber.fop.fo.PropertyList;

import com.jtauber.fop.apps.FOPException;

/**
 * base class for nodes in the formatting object tree
 */
abstract public class FONode {
	protected FObj parent;
	protected Vector children;
	protected Document doc;
	  
	protected FONode(Document doc, FObj parent) {
		this.parent = parent;
		this.doc = doc;
		this.children = new Vector();
	}
	protected void addChild(FONode child) {
		children.addElement(child);
	}
	protected FONode getParent() {
		return parent;
	}
	abstract public void layout() throws FOPException;
}