package com.jtauber.fop.fo;

import com.jtauber.fop.layout.Document;
import com.jtauber.fop.layout.FontState;

import com.jtauber.fop.fo.properties.*;

import com.jtauber.fop.apps.FOPException;

/**
 * a text node in the formatting object tree
 */
public class FOText extends FONode {
	private String text;
	
	protected FOText(Document doc, String text, FObj parent) {
		super(doc, parent);
		this.text = text;
	}
	public void layout() throws FOPException {

		String fontFamily = ((FontFamily)this.parent.properties.get("font-family")).string();
		String fontStyle = ((FontStyle)this.parent.properties.get("font-style")).string();
		String fontWeight = ((FontWeight)this.parent.properties.get("font-weight")).string();
		int fontSize = ((FontSize)this.parent.properties.get("font-size")).length().value();
		
		FontState fs = new FontState(doc.getFontInfo(),fontFamily,fontStyle,fontWeight,fontSize);

		//System.err.println(text);
		
		doc.addText(fs, this.text);
	}
}