package com.jtauber.fop.fo;

import java.util.Hashtable;

import com.jtauber.fop.apps.FOPException;

public class PropertyList extends Hashtable {
	private PropertyListBuilder builder;
	private PropertyList parentPropertyList = null;
public PropertyList(PropertyList parentPropertyList) {
	this.parentPropertyList = parentPropertyList;
}
	public Property get(String propertyName) {

		// return ((val == null) && (defaults != null)) ? defaults.getProperty(key) : val;

		Property p = (Property)super.get(propertyName);
		
		if (p == null) { // if not explicit
			if ((this.parentPropertyList != null)&&(this.builder.isInherited(propertyName))) { // check for parent
				p = this.parentPropertyList.get(propertyName); // retrieve parent's value
			} else { // else default
				try {
					p = this.builder.makeProperty(this,propertyName);
				} catch (FOPException e) {
					// don't know what to do here
				}
			}
		}
		return p;
	}
public void setBuilder(PropertyListBuilder builder) {
	this.builder = builder;
}
}