package com.jtauber.fop.fo.flow;

import com.jtauber.fop.fo.*;
import com.jtauber.fop.fo.properties.*;

import com.jtauber.fop.layout.Document;
import com.jtauber.fop.layout.FontState;

import com.jtauber.fop.apps.FOPException;

import java.util.Enumeration;

public class ListBlock extends FObj {
	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new ListBlock(doc, parent,propertyList);
		}
	}
	public ListBlock(Document doc, FObj parent, PropertyList propertyList) {
		super(doc,parent,propertyList);
		this.foName = "fo:list-block";
	}
	protected void addCharacters(char data[], int start, int length) {}
	protected void finishText() {}
	public void layout() throws FOPException {
		String fontFamily = ((FontFamily)this.properties.get("font-family")).string();
		String fontStyle = ((FontStyle)this.properties.get("font-style")).string();
		String fontWeight = ((FontWeight)this.properties.get("font-weight")).string();
		int fontSize = ((FontSize)this.properties.get("font-size")).length().value();
		
		FontState fs = new FontState(doc.getFontInfo(),fontFamily,fontStyle,fontWeight,fontSize);

		int startIndent = ((StartIndent)this.properties.get("start-indent")).length().value();
		int endIndent = ((EndIndent)this.properties.get("end-indent")).length().value();

		int spaceBefore = ((SpaceBeforeOptimum)this.properties.get("space-before.optimum")).length().value();
		int spaceAfter = ((SpaceAfterOptimum)this.properties.get("space-after.optimum")).length().value();

		int provisionalDistanceBetweenStarts = ((ProvisionalDistanceBetweenStarts)this.properties.get("provisional-distance-between-starts")).length().value();
		int provisionalLabelSeparation = ((ProvisionalLabelSeparation)this.properties.get("provisional-label-separation")).length().value();
		int spaceBetweenListRows = 0; // not used at present

		doc.startListBlockArea(fs,startIndent,endIndent,spaceBefore,provisionalDistanceBetweenStarts,provisionalLabelSeparation,spaceBetweenListRows);
		this.layoutChildren();		
		doc.endListBlockArea(spaceAfter);
	}
public static FObj.Maker maker() {
	return new ListBlock.Maker();
}
}