package com.jtauber.fop.fo.flow;

import com.jtauber.fop.fo.*;
import com.jtauber.fop.fo.properties.*;

import com.jtauber.fop.layout.Document;
import com.jtauber.fop.layout.FontState;

import com.jtauber.fop.apps.FOPException;

import java.util.Enumeration;

public class ListItem extends FObj {
	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new ListItem(doc, parent,propertyList);
		}
	}
	public ListItem(Document doc, FObj parent, PropertyList propertyList) {
		super(doc,parent,propertyList);
		this.foName = "fo:list-item";
	}
	protected void addCharacters(char data[], int start, int length) {}
	protected void finishText() {}
	public void layout() throws FOPException {
		String fontFamily = ((FontFamily)this.properties.get("font-family")).string();
		String fontStyle = ((FontStyle)this.properties.get("font-style")).string();
		String fontWeight = ((FontWeight)this.properties.get("font-weight")).string();
		int fontSize = ((FontSize)this.properties.get("font-size")).length().value();
		
		FontState fs = new FontState(doc.getFontInfo(),fontFamily,fontStyle,fontWeight,fontSize);

		int align = ((TextAlign)this.properties.get("text-align")).enum();
		int alignLast = ((TextAlignLast)this.properties.get("text-align-last")).enum();

		int lineHeight = ((LineHeight)this.properties.get("line-height")).length().value();

		int startIndent = ((StartIndent)this.properties.get("start-indent")).length().value();
		int endIndent = ((EndIndent)this.properties.get("end-indent")).length().value();

		int spaceBefore = ((SpaceBeforeOptimum)this.properties.get("space-before.optimum")).length().value();
		int spaceAfter = ((SpaceAfterOptimum)this.properties.get("space-after.optimum")).length().value();

		doc.startBlockArea(fs,align,alignLast,lineHeight,startIndent,endIndent,spaceBefore);
		this.layoutChildren();		
		doc.endBlockArea(spaceAfter);
	}
public static FObj.Maker maker() {
	return new ListItem.Maker();
}
}