package com.jtauber.fop.fo.pagination;

import com.jtauber.fop.fo.*;
import com.jtauber.fop.fo.properties.*;

import com.jtauber.fop.layout.Document;
import com.jtauber.fop.layout.Region;

import com.jtauber.fop.apps.FOPException;				   

public class RegionAfter extends FObj {
	
	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new RegionAfter(doc, parent,propertyList);
		}
	}

	SimplePageMaster layoutMaster;

	protected RegionAfter(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
		super(doc, parent, propertyList);
		this.foName = "fo:region-after";

		if (parent.foName.equals("fo:simple-page-master")) {
			this.layoutMaster = (SimplePageMaster)parent;
			this.layoutMaster.setRegionAfter(this);
		} else {
			throw new FOPException("fo:region-after must be child of fo:simple-page-master, not "+parent.foName);
		}
	}
	protected void addCharacters(char data[], int start, int length) {}
	protected void finishText() {}
/**
 * This method was created in VisualAge.
 * @return FObjMaker
 */
public static FObj.Maker maker() {
	return new RegionAfter.Maker();
}
	Region makeRegion(int cr_sx, int cr_sy, int cr_w, int cr_h) {
		int m_top = ((MarginTop)this.properties.get("margin-top")).length().value();
		int m_bottom = ((MarginBottom)this.properties.get("margin-bottom")).length().value();
		int m_left = ((MarginLeft)this.properties.get("margin-left")).length().value();
		int m_right = ((MarginRight)this.properties.get("margin-right")).length().value();
		int extent = ((Extent)this.properties.get("extent")).length().value();
		
		return new Region(cr_sx,cr_sy-cr_h+extent,cr_w,extent, m_top, m_bottom, m_left, m_right);
	}
}