package com.jtauber.fop.fo.pagination;

import com.jtauber.fop.fo.*;
import com.jtauber.fop.fo.properties.*;

import com.jtauber.fop.layout.Document;

import com.jtauber.fop.apps.FOPException;				   

import java.util.Vector;
import java.util.Enumeration;

public class Root extends FObj {

	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new Root(doc, parent, propertyList);
		}
	}
	
	LayoutMasterSet layoutMasterSet;
	Vector pageSequences;
		
	protected Root(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
		super(doc, parent, propertyList);
		this.foName =  "fo:root";
		
		pageSequences = new Vector();
		if (parent != null) {
			throw new FOPException("fo:root must be root element");
		}
	}
	protected void addCharacters(char data[], int start, int length) {}
	public void addPageSequence(PageSequence pageSequence) {
		this.pageSequences.addElement(pageSequence);
	}
	protected void finishText() {}
	public LayoutMasterSet getLayoutMasterSet() {
		return this.layoutMasterSet;
	}
	public void layout() throws FOPException {
		if (layoutMasterSet == null) {
			throw new FOPException("No layout master set.");
		}
		Enumeration e = pageSequences.elements();
		while (e.hasMoreElements()) {
			((PageSequence)e.nextElement()).layout(doc);
		}
	}
/**
 * This method was created in VisualAge.
 * @return FObjMaker
 */
public static FObj.Maker maker() {
	return new Root.Maker();
}
	public void setLayoutMasterSet(LayoutMasterSet layoutMasterSet) {
		this.layoutMasterSet = layoutMasterSet;
	}
}