package com.jtauber.fop.fo.pagination;

import com.jtauber.fop.fo.*;
import com.jtauber.fop.fo.properties.*;

import com.jtauber.fop.layout.Document;
import com.jtauber.fop.layout.PageMasterFactory;

import com.jtauber.fop.apps.FOPException;				   

public class SequenceSpecification extends FObj {

	public static class Maker extends FObj.Maker {
		public FObj make(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
			return new SequenceSpecification(doc, parent, propertyList);
		}
	}

	private PageSequence pageSequence;
	private LayoutMasterSet layoutMasterSet;
	private PageMasterFactory firstPMF;
	private PageMasterFactory currentPMF;
	
	protected SequenceSpecification(Document doc, FObj parent, PropertyList propertyList) throws FOPException {
		super(doc, parent, propertyList);
		this.foName = "fo:sequence-specification";

		if (parent.foName.equals("fo:page-sequence")) {
			this.pageSequence = (PageSequence)parent;
			this.pageSequence.setSequenceSpecification(this);
		} else {
			throw new FOPException("fo:sequence-specification must be child of fo:page-sequence, not "+parent.foName);
		}
		this.firstPMF = null;
		this.currentPMF = null;
	}
	protected void addCharacters(char data[], int start, int length) {}
	protected void addSequenceSpecifier(SequenceSpecifier sequenceSpecifier) {
		if (this.firstPMF == null) {
			this.firstPMF = sequenceSpecifier.getPageMasterFactory();
		} else {
			this.currentPMF.setNext(sequenceSpecifier.getPageMasterFactory());
		}
		this.currentPMF = sequenceSpecifier.getPageMasterFactory();
	}
	protected void finishText() {}
	protected PageMasterFactory getFirstPageMasterFactory() {
		return this.firstPMF;
	}
	LayoutMasterSet getLayoutMasterSet() {
		return this.layoutMasterSet;
	}
/**
 * This method was created in VisualAge.
 * @return FObjMaker
 */
public static FObj.Maker maker() {
	return new SequenceSpecification.Maker();
}
	protected void setLayoutMasterSet(LayoutMasterSet layoutMasterSet) {
		this.layoutMasterSet = layoutMasterSet;
	}
}