package com.jtauber.fop.fo.properties;

import com.jtauber.fop.fo.*;

import com.jtauber.fop.apps.FOPException;

public class ProvisionalLabelSeparation extends Property {
	
	public static class Maker extends Property.Maker {
		public boolean isInherited() { return true; }

		public Property make(PropertyList propertyList, String value) throws FOPException {
			return new ProvisionalLabelSeparation(propertyList, new Length(value));
		}

		public Property make(PropertyList propertyList) throws FOPException {
			return new ProvisionalLabelSeparation(propertyList, new Length("6pt"));
		}
	}

	private Length value;
	
public ProvisionalLabelSeparation(PropertyList propertyList, Length explicitValue) {
	super(propertyList);
	this.value = explicitValue;
}
public Length length() {
	return this.value;
}
public static Property.Maker maker() {
	return new ProvisionalLabelSeparation.Maker();
}
}