package com.jtauber.fop.fo.properties;

import com.jtauber.fop.fo.*;

import com.jtauber.fop.apps.FOPException;

public class TextAlignLast extends Property {
	
	public static class Maker extends Property.Maker {
		public boolean isInherited() { return true; }
		
		public Property make(PropertyList propertyList, String value) throws FOPException {
			int v;
			if (value.equals("centered")) { v = TextAlign.CENTERED; }
			else if (value.equals("end")) { v = TextAlign.END; }
			else if (value.equals("start")) { v = TextAlign.START; }
			else if (value.equals("justify")) { v  =TextAlign.JUSTIFY; }
			else {
				System.err.println("WARNING: Unknown value for text-align: " + value);
				v = TextAlign.START;
			}
			return new TextAlignLast(propertyList, v);
		}
		
		public Property make(PropertyList propertyList) throws FOPException {
			return new TextAlignLast(propertyList, TextAlign.START);
		}
		
	}

	private int value;
	
public TextAlignLast(PropertyList propertyList, int explicitValue) {
	super(propertyList);
	this.value = explicitValue;
}
public int enum() {
	return this.value;
}
public static Property.Maker maker() {
	return new TextAlignLast.Maker();
}
}