package com.jtauber.pdf;

import java.util.Vector;
import java.io.PrintWriter;

public class PDFPage extends PDFObject {
	private PDFPages parent;
	private PDFResources resources;
	private PDFStream contents;
	private int pagewidth;
	private int pageheight;

	/**
	 * create a /Page  with the given number
	 */
	public PDFPage(int number, PDFResources resources, PDFStream contents, int pagewidth, int pageheight) {
		super(number);
		this.resources = resources;
		this.contents = contents;
		this.pagewidth = pagewidth;
		this.pageheight = pageheight;
	}
public void setParent(PDFPages parent) {
	this.parent = parent;
}
public String toPDF() {
		String p = this.number + " " + this.generation + " obj\n";
		p += "<< /Type /Page\n";
		p += "/Parent " + this.parent.referencePDF() + "\n";
		p += "/MediaBox [ 0 0 " + this.pagewidth + " " + this.pageheight + " ]\n";
		p += "/Resources " + this.resources.referencePDF() + "\n";
		p += "/Contents " + this.contents.referencePDF() + " >>\n";
		p += "endobj\n";
		return p;
}
}