package com.jtauber.pdf;

import java.util.Enumeration;
import java.util.Hashtable;
import java.io.PrintWriter;

public class PDFResources extends PDFObject {
	private Hashtable fonts;
	/**
	 * create a resources with the given number
	 */
	public PDFResources(int number) {
		super(number);
		this.fonts = new Hashtable();
	}
	/**
	 * add given /Font object to /Resources
	 */
	public void addFont(PDFFont font) {
		this.fonts.put(font.getName(),font);
	}
public String toPDF() {
		String p = this.number + " " + this.generation + " obj\n";
		p += "<< /Font << ";

		Enumeration fontEnumeration = fonts.keys();
		String fontName;
		
		while (fontEnumeration.hasMoreElements()) {
			fontName = (String)fontEnumeration.nextElement();
			p += "/" + fontName + " " + ((PDFFont)fonts.get(fontName)).referencePDF() + "\n";
		}
		p += ">>\n";

		p += "/ProcSet [ /PDF /Text ] >>\n";
		
		p += "endobj\n";
		return p;
}
}