package com.jtauber.pdf;

/**
 * PDF Stream
 * 
 * A derivative of the PDF Object, a PDF Stream has not only a dictionary
 * but a stream of PDF commands. The stream of commands is where the real
 * work is done, the dictionary just provides information like the stream
 * length
 */
public class PDFStream extends PDFObject {
	private String data;
	/**
	 * create an empty stream object with the given number
	 */
	public PDFStream(int number) {
		super(number);
		this.data = new String();
	}
	/**
	 * append the given data to the stream
	 */
	public void add(String s) {
		this.data = this.data + s;
	}
	/**
	 * represent as PDF
	 * 
	 * <number> <generation> obj
	 * <dictionary>
	 * stream
	 * <stream>
	 * endstream
	 * endobj
	 */ 

	String toPDF() {
		String p = this.number + " " + this.generation + " obj\n";
		p = p + "<< /Length " + (this.data.length()+1) + " >>\n"; // add one for final \n
		p = p + "stream\n";
		p = p + this.data;
		p = p + "\nendstream\nendobj\n";
		return p;
	}
}